﻿using System;
using System.Collections.Generic;
using System.Text;
using DreamShield.Deployment.Wizards;

namespace DreamShield.Deployment.Miles.CustomPage
{
    /// <summary>
    /// Identifiant des pages de l'assistant
    /// </summary>
    public class WizardPagesID
    {
        /// <summary>
        /// Page de fin, lorsque l'installation a été annulée
        /// </summary>
        public const string CancelEndPage = StdWizardPageID.CancelEndPage;
        /// <summary>
        /// Page de progression de l'installation (mode configuration)
        /// </summary>
        public const string Config_Progress = StdWizardPageID.Config_Progress;
        /// <summary>
        /// Page de fin, lorsque l'installation a été un susccès
        /// </summary>
        public const string FinalEndPage = StdWizardPageID.FinalEndPage;
        /// <summary>
        /// Page de progression de l'installation (mode installation)
        /// </summary>
        public const string Install_ProgressPage = StdWizardPageID.Install_ProgressPage;
        /// <summary>
        /// Page de sélection des composants à installer
        /// </summary>
        public const string InstallationComponentsSelectPage = StdWizardPageID.InstallationComponentsSelectPage;
        /// <summary>
        /// Page de sélection du répertoire de destination
        /// </summary>
        public const string InstallationDirSelect = StdWizardPageID.InstallationDirSelect;
        /// <summary>
        /// Page de sélection du mode d'installation (Installation standard ou personnalisée)
        /// </summary>
        public const string InstallationModePage = StdWizardPageID.InstallationModePage;
        /// <summary>
        /// Page de progression de l'installation (ou désinstallation)
        /// </summary>
        public const string InstallationProgressPage = StdWizardPageID.InstallationProgressPage;
        /// <summary>
        /// Page affichée lorsque la configuration est prêt à être démarrée
        /// </summary>
        public const string InstallationReady = StdWizardPageID.InstallationReady;
        /// <summary>
        /// Page affichée lorsque l'installeur doit automatiquement désinstaller une ancienne version du programme
        /// </summary>
        public const string InstallationVersionOverwrite = StdWizardPageID.InstallationVersionOverwrite;
        /// <summary>
        /// Page de sélection des composants, lors de la désinstallation
        /// </summary>
        public const string UnInstallationComponentsSelectPage = StdWizardPageID.UnInstallationComponentsSelectPage;
        /// <summary>
        /// Page de sélection du mode de désinstallation (réinstaller, supprimer, modifier ...)
        /// </summary>
        public const string UninstallerModePage = StdWizardPageID.UninstallerModePage;
        /// <summary>
        /// Page de démarrage
        /// </summary>
        public const string WelcomePage = StdWizardPageID.WelcomePage;
    }
}
